/*
	Game Categories Light v 1.3
	Copyright (C) 2011, Bubbletune
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <pspsdk.h>
#include "gcpatches.h"

#define MAKE_CALL(a, f) _sw(0x0C000000 | (((u32)(f) >> 2)  & 0x03ffffff), a);
#define MAKE_JUMP(a, f) _sw(0x08000000 | (((u32)(f) & 0x0ffffffc) >> 2), a); 
#define MAKE_STUB(a, f) {u32 addr = a; _sw(0x08000000 | (((u32)(f) & 0x0ffffffc) >> 2), addr); _sw(0, addr+4); }
#define REDIRECT_FUNCTION(a, f) { u32 address = a; _sw(0x08000000 | (((u32)(f) >> 2)  & 0x03ffffff), address);  _sw(0, address+4); }
#define ClearCachesForUser sceKernelGetCompiledSdkVersion

typedef struct
{
	void *unknown;
	int option;
	const char *text;
} SceGameContext; 

typedef struct
{
	u32 addr;
	u32 opcode;
} ToggleCategoryPatch;

typedef struct
{
	void *next;
	u64 mtime;
	char letter;
	char name;
} Category;

typedef struct
{
//#if PSP_FIRMWARE_VERSION == 620
	u8 unk0[0x174];
//#elif PSP_FIRMWARE_VERSION == 631
//	u8 unk0[0xEC];
//#endif
	char gamecode[10];
	u8 unk1[0x5E];
	char firmware[5];
	u8 unk2[0x3];
	char category[3];
} SfoInfo;

enum
{
	OPTION_BY_EXPIRE_DATE,
	OPTION_ALL,
	// need dynamic
#if PSP_FIRMWARE_VERSION == 631
//	OPTION_BY_FORMAT,
#endif
//	OPTION_BY_CATEGORY,
};

enum
{
	MODE_ALL,
	// need dynamic
#if PSP_FIRMWARE_VERSION == 631
//	MODE_BY_FORMAT,
#endif
//	MODE_BY_EXPIRE_DATE,
//	MODE_BY_CATEGORY,
};

// Functions in scePaf
int scePafAddGameItems(void *unk, int count);
int scePafSetSelection(void *arg0, int selection);

// Functions in: selection.c
void PatchSelection(u32 text_addr);

// Functions in: mode.c
int ToggleCategoryMode(int mode);
void HijackGameClass();

// Functions in: io.c
void PatchIoFileMgrForGamePlugin(u32 text_addr);
void PatchIoFileMgrForVshmain(u32 text_addr);

// Functions in: category.c
int CountCategories();
void ClearCategories();
void AddCategory(char *category, u64 mtime);
Category *GetNextCategory(Category *prev);

// Functions in: gcpatches.c
void ResolveNIDs(int fw_group);
GCPatches *GetPatches(int fw_group);

// Functions in: clearcache.s
void ClearCaches();

// vsh_module
int vsh_function(void *arg);